VirtualBox: amministrazione da terminale

Da Guide@Debianizzati.Org.

VirtualBox

Sommario

Installazione e configurazione
Amministrazione
Altro

Indice

Introduzione

Info.png Nota
La configurazione della macchina host presa in esame per la guida prevede come indirizzo IP di eth0 il seguente: 192.168.0.100.

VirtualBox mette a disposizione lo strumento VBoxManage per creare e amministrare le macchine virtuali da terminale. È uno strumento molto potente e complesso e permette di gestire le proprie macchine virtuali in maniera molto dettagliata; ciononostante in questa guida vedremo solo i comandi e le opzioni principali.
Per una spiegazione dettagliata del tool consiglio di far riferimento alla User Guide di VirtualBox: VBoxManage.

Bulb.png Suggerimento
Onde evitare complicazioni al momento di avviare la VM si consiglia di decidere subito quale utente si intende usare per avviarla, in modo da usare subito il suddetto utente per la procedura di creazione della medesima.


Creazione di una Virtual Machine

Creiamo innanzitutto una directory dove conservare tutte le nostre macchine virtuali. Io la creerò sotto /opt, ma siete liberi di metterla dove meglio credete (ricordatevi di modificare il percorso nei comandi seguenti!):

# mkdir /opt/vm
Info.png Nota
Nel seguito la maggior parte dei comandi saranno preceduti dal simbolo di root '#', questo non perché sia necessario avere i privilegi di amministratore per creare e gestire delle macchine virtuali tramite VirtualBox, ma perché per questo esempio si è scelto di usare una cartella in cui di norma solo l'utente root ha i permessi di scrittura. Naturalmente nulla vieterebbe all'utente di modificare i permessi sulla cartella /opt/vm in modo da poter eseguire i successivi comandi come utente normale.


Procediamo quindi a creare la nostra virtual machine di prova:

# VBoxManage createvm --name prova --basefolder /opt/vm/ --register

Analizziamo il comando seguente:

Warning.png ATTENZIONE
Si noti che a meno di non indicare un percorso assoluto tutti i file e le cartelle saranno creati all'interno della directory ~/.Virtualbox dell'utente che sta creando la macchina virtuale.


Ora modifichiamo la configurazione della nostra nuova virtual machine:

# VBoxManage modifyvm prova --memory 1024 --acpi on --boot1 dvd --boot2 disk --nic1 bridged --bridgeadapter1 eth0 --ostype Windows2003 --usb on

Le modifiche che abbiamo introdotto nella nostra virtual machine sono le seguenti:

Ogni volta che, attraverso il parametro modifyvm apportate delle modifiche alla configurazione della vostra virtual machine, queste vengono registrate nel file XML creato in precedenza.

Info.png Nota
Nel succitato comando d'esempio per configurare l'interfaccia di rete virtuale si sono usate le opzioni --nic1 bridged --bridgeadapter1 eth0, tuttavia qualora non si abbia bisogno/voglia di configurare un bridge di rete perché ad esempio al sistema guest non saranno richieste particolari funzionalità di rete, allora è possibile optare per la modalità NAT sostituendo alle opzioni in questione la più semplice --nic1 nat. In questo modo l'utente non dovrà configurare nulla, tuttavia la macchina virtuale fungerà da firewall bloccando tutte le connessioni in entrata proprio come un router; in modalità NAT dunque qualora si avesse bisogno di rendere disponibile qualche servizio, come una connessione ssh tra host e guest, l'utente dovrà creare delle apposite regole come spiegato qui.

Ora preoccupiamoci di creare un hard disk virtuale per la nostra virtual machine:

# VBoxManage createhd --filename /opt/vm/prova/prova.vdi --size 10000 --register (l'opzione register non è più supportata in questo contesto almeno dalla versione 4.1)

Piccola spiegazione:


Installiamo quindi un controller IDE nella nostra Virtual Machine:

# VBoxManage storagectl "prova" --name "IDE Controller" --add ide --controller ICH6

Infine modifichiamo la virtual machine collegandole il disco virtuale che abbiamo appena creato con uno dei seguenti due comandi:

# VBoxManage modifyvm prova -hda /opt/vm/prova/prova.vdi

oppure:

# VBoxManage storageattach "prova" --storagectl "IDE Controller" --port 0 --device 0 --type hdd --medium "/opt/vm/prova/prova.vdi"

Possiamo collegare alla nostra macchina un massimo di 3 hard disk virtuali (hda, hdb, hdd). hdc è riservato per il CD/DVD.

Arrivati a questo punto dobbiamo montare un'immagine ISO o un CD/DVD nel nostro lettore CD/DVD virtuale, in modo di poter installare il nostro sistema operativo virtuale. In questo esempio monterò un'immagine ISO:

# VBoxManage openmedium dvd /home/ferdy/w2003.iso (valido solo per le versioni inferiori alla 4.0)
# VBoxManage storageattach "prova" --storagectl "IDE Controller" --port 1 --device 0 --type dvddrive --medium "/home/ferdy/w2003.iso"

Se invece vogliamo utilizzare il lettore CD/DVD della macchina host, anziché ricorrere all'utilizzo di un'immagine ISO, allora:

# VBoxManage storageattach "prova" --storagectl "IDE Controller" --port 1 --device 0 --type dvddrive --medium Host:/dev/cdrom

Avvio di una macchina virtuale

Info.png IMPORTANTE
  • Qualora si abbia la necessità di accedere a dispositivi USB ricordarsi di aggiungere l'utente usato per creare e amministrare le macchine virtuali al gruppo vboxusers:
# adduser nome_utente vboxusers
  • Una macchina virtuale creata e registrata da un certo utente non sarà avviabile da utenti diversi dal medesimo, a meno di non ripetere la procedura di configurazione e registrazione della macchina anche per gli altri utenti o di esportarla e poi importarla.


Metodo 1

Warning.png ATTENZIONE
Per utilizzare il protocollo VRDP è necessario aver installato l'extension pack


Arrivati a questo punto è possibile avviare la macchina virtuale con il comando:

# VBoxHeadless --startvm prova

Il comando VBoxHeadless avvia la virtual machine indicata e nel contempo inizializza una sessione VRDP Server (Virtual Remote Desktop Protocol). Purtroppo però, pur essendo il comando suggerito dalla User Guide di VirtualBox, ha il difetto di bloccare la sessione di terminale fino allo spegnimento della macchina virtuale. Per questo motivo consiglio di avviare una virtual machine con il comando alternativo:

# VBoxHeadless --startvm prova &

che non sempre funziona, oppure:

# VBoxManage startvm prova --type vrdp (vecchia sintassi)
# VBoxManage startvm prova --type headless

dagli effetti identici al primo, ma senza che la nostra shell sia resa inutilizzabile. Si noti che in virtualbox i parametri per configurare vrdp contengono la parola chiave vrde (e non appunto vrdp come inve ci si potrebbe aspettare).

Metodo 2

Un secondo metodo, molto simile al precedente, prevede di usare in primis screen per generare una sessione di terminale aggiuntiva in cui avviare la macchina virtuale, in secondo luogo di usare il protocollo VNC al posto di VRDE (che come già detto è la versione oracle di VRDP). Un volta avviato screen e superata la schermata di benvenuto digitare:

# VBoxHeadless -s prova -n -m numero_porta

Gestione di una macchina virtuale

Condividere una o più directory tra host e guest

A macchina virtuale spenta è possibile mettere in condivisione automaticamente una o più risorse col seguente comando:

# VBoxManage sharedfolder add prova --name "nome_arbitrario" --hostpath "/percorso/risorsa/host" --automount

In windows aprendo esplora risorse dette cartelle figureranno ciascuna come dischi di rete cui è già stata assegnata la prima lettera dell'alfabeto disponibile, mentre in linux risulteranno visibili sotto /media, ma ai loro nomi sarà stato sistematicamente aggiunto il prefisso sf. Per maggiori informazioni si veda l'apposita pagina del manuale.

Collegamento alla VM da Windows XP

Aprite "Connessione Desktop Remoto" e digitate l'indirizzo IP del vostro server Debian: si aprirà la console della macchina virtuale che avete avviato.

Comandi utili di "Connessione Desktop Remoto"

Collegamento alla VM da Linux

Info.png Importante
A partire dalla versione 4.1.X la connessione tramite vrde/vrdp è possibile solo dopo aver installato l'extension pack sulla macchina host, anche se la macchina virtuale viene avviata specificando di usare vrde/vrdp.


VRDE (VRDP)

Dalla macchina client aprire un terminale e digitare:

$ rdesktop -a 16 192.168.0.100

Si aprirà la console della macchina virtuale che avete avviato.
Alternativamente è possibile usare altri applicativi come vinagre (in tal caso ricordarsi di selezionare il giusto protocollo, cioè RDP e non VNC!) e gnome-rdp in GNOME, o krdc in KDE.

VNC

Se per un qualsiasi motivo non si riesce (o non si vuole) usare VRDE, perché per esempio si riceve un messaggio d'errore come il seguente:

Autoselected keyboard map it
ERROR: nome_macchina: unable to connect

provare ad avviare VBoxHeadless specificando VNC come protocollo (opzione -n, si veda il precedente paragrafo metodo 2) ed usare dei client VNC, come i già citati vinagre e krdc.

Arresto della VM

Per arrestare la macchina virtuale è possibile sfruttare l'apposita funzione all'interno del sistema guest se si è collegati tramite un client vnc, oppure direttamente dal terminale del server digitando:

# VBoxManage controlvm prova savestate

Un metodo più brutale è il seguente:

VBoxManage controlvm prova poweroff

che è l'equivalente di togliere la spina ad una macchina reale.
Terminata l’installazione del sistema operativo, il DVD può essere rimosso dalla Virtual Machine col comando:

# VBoxManage storageattach "prova" --storagectl "IDE Controller" --port 1 --device 0 --type dvddrive --medium none

Qualora l’immagine DVD non sia più necessaria, esiste la possibilità di de-registrarla dal database di VirtualBox:

# VBoxManage closemedium dvd "/home/ferdy/w2003.iso"

Importazione di una Virtual Machine

Se abbiamo già una virtual machine creata in precedenza, possiamo importarla all'interno della nostra installazione di VirtualBox per poi avviarla. Per importare una virtual machine esistente si utilizzi il comando:

# VBoxManage registervm /opt/vm/prova2/prova2.xml

Avvio automatico di una Virtual Machine

Warning.png ATTENZIONE
  • È bene ricordare che una macchina virtuale creata e registrata da un certo utente non sarà avviabile da utenti diversi dal medesimo, a meno di non ripetere la procedura di configurazione e registrazione della macchina anche per gli altri utenti o di esportarla e poi importarla.
  • Non usare nomi contenenti spazi per le VM che si vuole avviare automaticamente.


Per avviare una virtual machine come demone al boot di Debian sono sufficienti pochi passi.

Innanzitutto creiamo un file per il nostro script di boot:

# nano /etc/init.d/provavm

e inseriamoci questo codice:

#! /bin/sh
### BEGIN INIT INFO
# Provides: VirtualBox - VM di Prova
# Required-Start: vboxdrv
# Required-Stop:  vboxdrv
# Default-Start: 2 3 4 5
# Default-Stop: S 0 1 6
# Description: VirtualBox Virtual Machine
### END INIT INFO

# Author: Ferdinando Bassi per Debianizzati.org

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/usr/sbin:/usr/bin:/sbin:/bin

#
# DA CAMBIARE E DA ADATTARE
#
# Name given to the virtual machine
VM_NAME="prova"

# Name of this file, excluding /etc/init.d/
THIS_FILE=provavm

# Username to run as
RUNAS_USERNAME=root

#
# FINE SEZIONE DA MODIFICARE
#

DESC="VirtualBox - ${VM_NAME}"
DAEMON=/usr/bin/VBoxVRDP
DAEMON_ARGS="-startvm \"${VM_NAME}\""
PIDFILE=/var/run/$THIS_FILE.pid
SCRIPTNAME=/etc/init.d/$THIS_FILE

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$THIS_FILE ] && . /etc/default/$THIS_FILE

# Load the VERBOSE setting and other rcS variables
[ -f /etc/default/rcS ] && . /etc/default/rcS

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
# Return
# 0 if daemon has been started
# 1 if daemon was already running
# 2 if daemon could not be started
#start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
#|| return 1
#start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
#$DAEMON_ARGS \
#|| return 2
# Add code here, if necessary, that waits for the process to be ready
# to handle requests from services started subsequently which depend
# on this one. As a last resort, sleep for some time.

su $RUNAS_USERNAME -c "VBoxManage startvm ${VM_NAME} --type vrdp"
}

#
# Function that stops the daemon/service
#
do_stop()
{
# Return
# 0 if daemon has been stopped
# 1 if daemon was already stopped
# 2 if daemon could not be stopped
# other if a failure occurred
start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $THIS_FILE
RETVAL="$?"
[ "$RETVAL" = 2 ] && return 2
# Wait for children to finish too if this is a daemon that forks
# and if the daemon is only ever run from this initscript.
# If the above conditions are not satisfied then add some other code
# that waits for the process to drop all resources that could be
# needed by services started subsequently. A last resort is to
# sleep for some time.

su $RUNAS_USERNAME -c "VBoxManage controlvm ${VM_NAME} savestate"

start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
[ "$?" = 2 ] && return 2
# Many daemons don't delete their pidfiles when they exit.
rm -f $PIDFILE
return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
#
# If the daemon can reload its configuration without
# restarting (for example, when it is sent a SIGHUP),
# then implement that here.
#
# start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
echo "Reload not supported"
return 0
}

case "$1" in
start)
[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$THIS_FILE"
do_start
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
stop)
[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$THIS_FILE"
do_stop
case "$?" in
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
esac
;;
#reload|force-reload)
#
# If do_reload() is not implemented then leave this commented out
# and leave 'force-reload' as an alias for 'restart'.
#
#log_daemon_msg "Reloading $DESC" "$NAME"
#do_reload
#log_end_msg $?
#;;
*)
#echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
echo "Usage: $SCRIPTNAME {start|stop}" >&2
exit 3
;;
esac

:

I parametri che l'utente può/deve modificare secondo le sue convenzioni sono tre:

Rendiamo eseguibile lo script appena creato:

# chmod 755 /etc/init.d/provavm

e creiamo i link alle directory rcX.d:

# update-rc.d provavm defaults 90 90

Da questo momento possiamo gestire il servizio con i soliti comandi:

# /etc/init.d/provavm start|stop

Disabilitazione script

Qualora si rendesse necessario disabilitare l'avvio automatico è sufficiente digitare da terminale:

# update-rc.d -f provavm remove

Rimuovere fisicamente lo script dalla directory /etc/init.d/ è facoltativo.

Salvare uno snapshot di una Virtual Machine

Anche da linea di comando è possibile lavorare con gli snapshot di una macchina virtuale. Vediamo come.

# VBoxManage snapshot prova take prova1 --description descrizione
# VBoxManage snapshot prova discard prova1
# VBoxManage snapshot prova discardcurrent --state
# VBoxManage snapshot prova discardcurrent --all

Condividere cartelle tra host e guest

Si veda l'omonima sezione della guida dedicata all' interfaccia grafica.

Aggiunta di una seconda Virtual Machine

Nel caso volessimo avere più di una Virtual Machine sullo stesso server fisico, occorrerà ripetere per ogni macchina virtuale le operazioni descritte fino a qui.

In più sarà necessario indicare a VirtualBox la porta RDP su cui mettere in ascolto ogni altra Virtual Machine diversa dalla prima, tenendo a mente che ad ogni porta può corrispondere solo una macchina virtuale. Poichè di default VRDP si pone in ascolto sulla porta 3389 (a questa porta risponderà la prima Virtual Machine installata), impostiamo come porta per la nostra seconda Virtual Machine la porta successiva:

# VBoxManage modifyvm "SecondaVM" --vrdp on --vrdpport 3390 --vrdpauthtype null --vrdpmulticon on

In questa maniera otterremo due macchine virtuali, entrambe avviabili al boot del server; la prima in ascolto sulla porta 3389, la seconda in ascolto sulla porta 3390 all'indirizzo IP del nostro server.

Eliminazione di una macchina virtuale

Warning.png ATTENZIONE
Tutte le seguenti operazioni vanno effettuate a VM spenta.


# VBoxManage unregistervm prova --delete

L'opzione --delete permette una contestuale eliminazione dei file associati. Qualora la cartella /opt/vm/prova non fosse stata automaticamente eliminata provvedere manualmente per recuperare spazio su disco.

Secondariamente rimuovere dai dispositivi conosciuti il disco dati:

VBoxManage closemedium disk /opt/vm/prova/prova.vdi
Strumenti personali
Namespace
Varianti
Azioni
Navigazione
Risorse
Strumenti